<script>
	import { createEventDispatcher } from "svelte"

	import { isLight } from "@/stores/static"

	export let value = ""
	export let placeholder
	export let type = "text"
	export let required = false
	export let style = "light"

	let input

	const emitInput = createEventDispatcher("input")

	const handleInput = e => {
		emitInput(e)

		value = e.target.value
	}

	$: {
		if (input) input.value = value

		if (input && !value) input.setAttribute("value", value)
	}
</script>

<input 
	bind:this={input}
	{type}
	{placeholder}
	class="input {style || ''}"
	class:dark={!$isLight}
	on:input={handleInput}
	value=""
	oninput="this.setAttribute('value', this.value)">

{#if $$slots.default && style == "dark"}
	<label class="label is-flex is-align-items-center">
		<slot />
		{#if required}
			<span class="has-text-red">&nbsp;*</span>
		{/if}
	</label>
{/if}

<style lang="scss">
input {
	line-height: 1.5rem;
	width: 100%;
	outline: none!important;
}

input[type=number] {
	-moz-appearance: textfield;
	&::-webkit-outer-spin-button,
	&::-webkit-inner-spin-button {
		-webkit-appearance: none;
		margin: 0;
	}
}

input.light {
	padding: calc(.5rem - 1px) 1rem;
	border: 1px solid $gray-dark;
	background: $gray;
	transition: 
		background .2s ease-in-out,
		border-color .2s ease-in-out;
	&.dark {
		background: #2E2E2E;
		border-color: #434343;
	}
}

input.light,
input.light::placeholder {
	font-size: .875rem;
	font-weight: 300;
	color: $gray-text;
}
</style>